/*
 *  Copyright 2012 by The Cogchar Project (www.cogchar.org).
 * 
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 * 
 *       http://www.apache.org/licenses/LICENSE-2.0
 * 
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 */

/*
 * FullCharPanel.java
 *
 * Created on Jan 12, 2012, 5:51:15 PM
 */

package org.cogchar.render.opengl.bony.gui;

import java.awt.Canvas;
import javax.swing.JFrame;
import javax.swing.JPanel;
import org.cogchar.render.opengl.bony.app.TwistController;

/**
 *
 * @author Stu B. <www.texpedient.com>
 */
public class FullCharPanel extends javax.swing.JPanel implements VirtualCharacterPanel {

    /** Creates new form FullCharPanel */
    public FullCharPanel() {
        initComponents();
    }
	@Override public void setRenderCanvas (Canvas c) {
		myVCP.setRenderCanvas(c);
	}	
	@Override public JFrame makeEnclosingJFrame(String title) {
		return PanelUtils.makeEnclosingJFrame(this, title);
	}	
	@Override public JPanel getJPanel() {
		return this;
	}

	@Override public TwistController getTwistController() {
		return myVTP;
	}
	
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        myVCP = new org.cogchar.render.opengl.bony.gui.VirtCharPanel();
        myHTP = new org.cogchar.render.opengl.bony.gui.HorizontalToolPanel();
        myVTP = new org.cogchar.render.opengl.bony.gui.VerticalToolPanel();

        setLayout(new java.awt.BorderLayout());

        myVCP.setPreferredSize(new java.awt.Dimension(800, 600));
        add(myVCP, java.awt.BorderLayout.CENTER);

        myHTP.setMinimumSize(new java.awt.Dimension(100, 50));
        myHTP.setPreferredSize(new java.awt.Dimension(880, 60));

        javax.swing.GroupLayout myHTPLayout = new javax.swing.GroupLayout(myHTP);
        myHTP.setLayout(myHTPLayout);
        myHTPLayout.setHorizontalGroup(
            myHTPLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 880, Short.MAX_VALUE)
        );
        myHTPLayout.setVerticalGroup(
            myHTPLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 60, Short.MAX_VALUE)
        );

        add(myHTP, java.awt.BorderLayout.SOUTH);

        myVTP.setPreferredSize(new java.awt.Dimension(80, 600));
        add(myVTP, java.awt.BorderLayout.EAST);
    }// </editor-fold>//GEN-END:initComponents
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private org.cogchar.render.opengl.bony.gui.HorizontalToolPanel myHTP;
    private org.cogchar.render.opengl.bony.gui.VirtCharPanel myVCP;
    private org.cogchar.render.opengl.bony.gui.VerticalToolPanel myVTP;
    // End of variables declaration//GEN-END:variables
}
